macro
: 1+ $40 1, ; : 1- $48 1, ;
: swap $0687 2, ; : drop $ad 1, ; 
: nip $04c683 3, ; : false $f9 1, ;
: true $f8 1, ; : vector $90909090 , $90 1, ;
forth
: swap swap ; : drop drop ;
: nip nip ; : dup [ $fc4689 3, $fc768d 3, ] ;
: and [ $0623 2, ] nip ; : or [ $060b 2, ] nip ;
: xor [ $0633 2, ] nip ; : not -1 xor ; 
: @ [ $008b 2, ] ; : ! [ $adc289 3, $ad0289 3, ] ;
: c@ @ $ff and ; : c! [ $adc289 3, $ad0288 3, ] ;
: w! [ $068bc289 , $8b028966 , $768d0446 , $08 1, ] ;
: w@ @ $ffff and ;
: hex 16 base ! ; : decimal 10 base ! ;
: binary 2 base ! ; : octal 8 base ! ;
: + [ $0603 2, ] nip ; : * [ $26f7 2, ] nip ;
: - [ $ad0629 3, ] ; : negate -1 * ;
: /mod [ $c389 2, $99ad 2, $fbf7 2, ] dup [ $d089 2, ] ;
: / /mod drop ; : mod /mod nip ;
: 1+ 1+ ; : 1- 1- ;
: wsparse 32 parse ; : lnparse 10 parse ;
: >> [ $c189 2, $d3ad 2, $e8 1, ] ;
: << [ $c189 2, $d3ad 2, $e0 1, ] ;
: here h0 @ ;
macro
: f: wsparse find compile ;
: m: wsparse mfind compile ;
: ['] wsparse find m: literal ;
: : wsparse entry ; : c: m: ['] ['] compile compile ;
: >r $ad50 2, ; : r> c: dup $58 1, ;
: r m: r> $50 1, ;
: prior last @ >r last @ @ last ! wsparse find compile r> last ! ;
: repeat here ; : again compile m: ;; ;
: next m: r> $48 1, $c009 2, $850f 2, here - 4 - , $ad 1, ;
: for here m: >r ;
: (if) $063b 2, $adad 2, 1, here 0 1, ;
: <>if $74 m: (if) ; : =if $75 m: (if) ;
: <if $7e m: (if) ; : >if $7d m: (if) ;
: ?if $72 1, here 0 1, ; : then dup here swap - 1- swap c! $90 1, ;
forth
: cells 4 * ; : cell+ 4 + ; : cell- 4 - ;
: later r> r> swap >r >r ; : exit, $c3 1, ;
: create: wsparse entry ; : variable 0 : variable: create , ;
: rot >r swap r> swap ; : -rot swap >r swap r> ;
: over >r dup r> swap ; : tuck dup -rot ;
: 2dup over over ; : 2drop drop drop ;
: ' wsparse find ; : alias create: last @ cell+ ! ;
: execute >r ; : 0; dup 0 =if r> 2drop then ;
: literal, m: literal ; : constant create: literal, exit, ;
: +! dup @ rot + swap ! ; : -! dup @ rot - swap ! ;
: allot h0 +! ; : is here swap ' h0 ! compile m: ;; h0 ! ;
: devector $90909090 ' $90 over c! 1+ ! ;
create list 5 cells allot
: loc: 1 list +! list @ cells list + last @ swap ! ;
: ;loc list @ cells list + @ last ! 1 list -! ;
: fill swap for swap 2dup c! 1+ swap next 2drop ;
: move for swap 2dup c@ swap c! 1+ swap 1+ next 2drop ;
: pad here 1024 + ; : >pad dup >r pad swap move pad r> ;
: " '" parse dup 0; drop >pad ;
: ." " type ;
loc:
: string, here 20 + over swap literal, literal, ;
here ] string, $eb 1, dup 1, dup >r here swap move r> allot ;
;loc alias $,
macro
: s" " $, ; : ." " $, c: type ;
: < '> parse $, c: eval ;
forth
: . dup 0 <if '- emit negate then : u. # : space 32 emit ;
: cr 10 emit ;
reset
: ui vector ;
: exit < devector ui > ;
here ] repeat ui interpret again ;
macro
: ( ') parse 2drop ;
forth
: | lnparse 2drop ;
loc:
variable size
: place here swap move here ;
: make dup -rot place swap dup allot 0 1, 1+ size +! ;
: free size @ negate allot 0 size ! ;
here ] make later free ;
;loc alias zt
: words last repeat @ 0; dup 9 + dup 1- c@ type space again ;
: .s 10 for r 1- [ $86048b 3, ] . next cr ;
108 constant version
: ? ." RETRO " version 100 /mod # '. emit # cr ;
: clear scr_size for space next home ;
: (fg) $fffff0ff swap 8 << setAttr ;
: (bg) $ffff0fff swap 12 << setAttr ;
: black 0 (fg) ; : blue 1 (fg) ; : green $B (fg) ;
: cyan 3 (fg) ; : red 5 (fg) ;
: brown 6 (fg) ; : white 4 (fg) ; : yellow $E (fg) ;
: brightWhite 15 (fg) ;
: onBlack 0 (bg) ; : onBlue 1 (bg) ; : onGreen $B (bg) ;
: onCyan 3 (bg) ; : onRed 5 (bg) ;
: onBrown 6 (bg) ; : onWhite 4 (bg) ; : onYellow $E (bg) ;
: onBrightWhite 15 (bg) ;
: normal white onBlack clear ;
variable blk 64 variable: #blks
: (block) blk @ : block 512 * there + ;
: (line) 64 * (block) + ;
: p 1 blk -! ; : n 1 blk +! ;
: d (line) 64 32 fill ; : x (block) 512 32 fill ;
: eb (block) 512 eval ; : el (line) 64 eval ;
: e 8 for 8 r - el next ; : s blk ! ;
: i 0 swap : ia (line) + lnparse rot swap move ;
: \ 1 s e ; : \f there #blks @ 512 * eval ; 
: use vector ; : blocks #blks ! ;
: load use : r vector ; : w vector ;
: new there #blks @ 512 * 32 fill 0 s ;
new
loc:
: .block ." Block: " blk @ . ." of " #blks @ . ; 
: status .block ." Stack: " .s ;
: row dup 64 type 64 + cr ;
: .line 8 swap - . ;
: rows 8 for r .line row next ;
: x--- 4 for ." +---:---+---:---" next ;
: --- space space x--- cr ;
here ] --- blk @ block rows drop --- status ;
;loc alias v
forth
: p1@ [ $c289 2, $ec 1, $c0b60f 3, ] ;
: p1! [ $068bc289 , $04468bee , $08768d 3, ] ;
: p2@ [ $ed66c289 , $c0b70f 3, ] ;
: p2! [ $068bc289 , $468bef66 , $08768d04 , ] ;
loc:
create fn 256 allot
: erase fn 256 0 fill ;
: use erase wsparse fn swap move ;
: r there fn 0 0 0 0 18 syscall ;
' r ' use
;loc alias use alias r
: load use f: r ;
loc:
: erase 160 for space next ;
: clr home 10 for cr next erase home ;
: display clr v ;
here ] clear display ['] display < is ui > ;
;loc alias edit
